curl --request POST \
--url https://api.env0.com/cloud-compass/drafts/{id}/verify \
--header 'Authorization: Basic <encoded-value>' \
--header 'Content-Type: application/json' \
--data '
{
"organizationId": "<string>",
"roleArn": "<string>",
"awsOrganizationId": "<string>",
"curExportName": "<string>",
"curBucket": "<string>",
"curPrefix": "<string>"
}
'import requests
url = "https://api.env0.com/cloud-compass/drafts/{id}/verify"
payload = {
"organizationId": "<string>",
"roleArn": "<string>",
"awsOrganizationId": "<string>",
"curExportName": "<string>",
"curBucket": "<string>",
"curPrefix": "<string>"
}
headers = {
"Authorization": "Basic <encoded-value>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Basic <encoded-value>', 'Content-Type': 'application/json'},
body: JSON.stringify({
organizationId: '<string>',
roleArn: '<string>',
awsOrganizationId: '<string>',
curExportName: '<string>',
curBucket: '<string>',
curPrefix: '<string>'
})
};
fetch('https://api.env0.com/cloud-compass/drafts/{id}/verify', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.env0.com/cloud-compass/drafts/{id}/verify",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'organizationId' => '<string>',
'roleArn' => '<string>',
'awsOrganizationId' => '<string>',
'curExportName' => '<string>',
'curBucket' => '<string>',
'curPrefix' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Basic <encoded-value>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.env0.com/cloud-compass/drafts/{id}/verify"
payload := strings.NewReader("{\n \"organizationId\": \"<string>\",\n \"roleArn\": \"<string>\",\n \"awsOrganizationId\": \"<string>\",\n \"curExportName\": \"<string>\",\n \"curBucket\": \"<string>\",\n \"curPrefix\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Basic <encoded-value>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.env0.com/cloud-compass/drafts/{id}/verify")
.header("Authorization", "Basic <encoded-value>")
.header("Content-Type", "application/json")
.body("{\n \"organizationId\": \"<string>\",\n \"roleArn\": \"<string>\",\n \"awsOrganizationId\": \"<string>\",\n \"curExportName\": \"<string>\",\n \"curBucket\": \"<string>\",\n \"curPrefix\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.env0.com/cloud-compass/drafts/{id}/verify")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Basic <encoded-value>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"organizationId\": \"<string>\",\n \"roleArn\": \"<string>\",\n \"awsOrganizationId\": \"<string>\",\n \"curExportName\": \"<string>\",\n \"curBucket\": \"<string>\",\n \"curPrefix\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"draftId": "<string>",
"organizationId": "<string>",
"accountMode": "single",
"setupMethod": "guided",
"externalId": "<string>",
"draftStatus": "waiting",
"createdAt": "2023-11-07T05:31:56Z",
"failureReason": "stack_rolled_back",
"stackOutputs": {
"roleArn": "<string>",
"awsAccountId": "<string>",
"awsOrganizationId": "<string>",
"organizationLookupFailed": true,
"curExportName": "<string>",
"curBucket": "<string>",
"curPrefix": "<string>"
},
"testResults": [
{
"feature": "asset_inventory",
"status": "created",
"failureReason": "<string>",
"failureCode": "<string>"
}
]
}Start the CloudQuery test connections of a Cloud Compass draft
Returns 202 at once. Poll GET cloud-compass/drafts/ for the result per feature. Manual verify sends the role ARN and the CUR outputs; guided verify uses the stack outputs.
curl --request POST \
--url https://api.env0.com/cloud-compass/drafts/{id}/verify \
--header 'Authorization: Basic <encoded-value>' \
--header 'Content-Type: application/json' \
--data '
{
"organizationId": "<string>",
"roleArn": "<string>",
"awsOrganizationId": "<string>",
"curExportName": "<string>",
"curBucket": "<string>",
"curPrefix": "<string>"
}
'import requests
url = "https://api.env0.com/cloud-compass/drafts/{id}/verify"
payload = {
"organizationId": "<string>",
"roleArn": "<string>",
"awsOrganizationId": "<string>",
"curExportName": "<string>",
"curBucket": "<string>",
"curPrefix": "<string>"
}
headers = {
"Authorization": "Basic <encoded-value>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Basic <encoded-value>', 'Content-Type': 'application/json'},
body: JSON.stringify({
organizationId: '<string>',
roleArn: '<string>',
awsOrganizationId: '<string>',
curExportName: '<string>',
curBucket: '<string>',
curPrefix: '<string>'
})
};
fetch('https://api.env0.com/cloud-compass/drafts/{id}/verify', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.env0.com/cloud-compass/drafts/{id}/verify",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'organizationId' => '<string>',
'roleArn' => '<string>',
'awsOrganizationId' => '<string>',
'curExportName' => '<string>',
'curBucket' => '<string>',
'curPrefix' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Basic <encoded-value>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.env0.com/cloud-compass/drafts/{id}/verify"
payload := strings.NewReader("{\n \"organizationId\": \"<string>\",\n \"roleArn\": \"<string>\",\n \"awsOrganizationId\": \"<string>\",\n \"curExportName\": \"<string>\",\n \"curBucket\": \"<string>\",\n \"curPrefix\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Basic <encoded-value>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.env0.com/cloud-compass/drafts/{id}/verify")
.header("Authorization", "Basic <encoded-value>")
.header("Content-Type", "application/json")
.body("{\n \"organizationId\": \"<string>\",\n \"roleArn\": \"<string>\",\n \"awsOrganizationId\": \"<string>\",\n \"curExportName\": \"<string>\",\n \"curBucket\": \"<string>\",\n \"curPrefix\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.env0.com/cloud-compass/drafts/{id}/verify")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Basic <encoded-value>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"organizationId\": \"<string>\",\n \"roleArn\": \"<string>\",\n \"awsOrganizationId\": \"<string>\",\n \"curExportName\": \"<string>\",\n \"curBucket\": \"<string>\",\n \"curPrefix\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"draftId": "<string>",
"organizationId": "<string>",
"accountMode": "single",
"setupMethod": "guided",
"externalId": "<string>",
"draftStatus": "waiting",
"createdAt": "2023-11-07T05:31:56Z",
"failureReason": "stack_rolled_back",
"stackOutputs": {
"roleArn": "<string>",
"awsAccountId": "<string>",
"awsOrganizationId": "<string>",
"organizationLookupFailed": true,
"curExportName": "<string>",
"curBucket": "<string>",
"curPrefix": "<string>"
},
"testResults": [
{
"feature": "asset_inventory",
"status": "created",
"failureReason": "<string>",
"failureCode": "<string>"
}
]
}Authorizations
env zero API authentication is done via API keys. An API Key can either be created by an organization administrator, in which case it will not be connected to any specific user, or via Personal API Keys to authenticate as a user.
Creating an API Key with a Specific Role
- Once you've created your organization, you can set up and manage API Keys.
- Navigate to the Organization Settings page and click the API Keys tab.
- Click Add API Key and enter a name for your key in the Name field. This name is for reference purposes only and isn't used directly in authentication.
❗️Save Your API Key ID and secret The secret will not be available after you close this window.
Creating a Personal API Key
- Click on your avatar (located on the top right of the screen)
- Click on Personal Settings
- Select the API Keys tab
- Click Add API Key, and enter a name for your key in the Name field. This name is for reference purposes and isn't used directly in authentication.
❗️Save your API Key ID & secret The secret will not be available after you close this window.
Using an API Key to Authenticate
Authentication of the env zero API is done using the Basic Authentication method. Each request made should include the API Key ID as the username, and the API Key secret as the password. For example, when using curl, we can include these parameters via flag --user {API Key ID}:{API Key Secret}.
API Key Permissions
When creating an API key through the organization settings, you will need to choose if you’d like to grant it Organization Admin or User permissions. In case of the latter, you can assign fine-grained permissions per project. Personal API Keys can be created through the user’s profile page and will have the same permissions as the user has.
Rate Limits
env zero API allows up to 1K requests per 60 seconds, requests are aggregated by IP, HTTP Method and URI. If you exceed this limit, you will receive a 429 status code.
Path Parameters
Body
Manual verify sends roleArn and the 3 CUR fields. Guided verify sends none and uses the stack outputs.
^arn:aws[a-z-]*:iam::\d{12}:role/.+$The AWS Organization of the account, if any. Used only for the overlap check.
^o-[a-z0-9]{10,32}$111Response
single, organization guided, manual waiting, stack_done, verifying, verified, failed stack_rolled_back, callback_timeout, test_connection_failed, test_connection_timeout Show child attributes
Show child attributes
The CloudQuery test connection result per feature, once verify has started.
Show child attributes
Show child attributes
Was this page helpful?